<template> 
    <v-container> 
        <v-form ref="form" v-model="valid" lazy-validation>
            <v-card class="mt-5">
                <v-card-title>Upload</v-card-title>
                <v-card-text>
                    First select a GTFS file to validate: 
                    <v-row>
                        <v-col cols="12" sm="4">
                            <v-file-input v-model="file" prepend-icon=""
                                          label="Select a file" 
                                          hint="GTFS File to deploy"
                                          :rules="[() => !!file || 'Required.']"
                                          persistent-hint/>
                        </v-col>
                        <v-col cols="12" sm="4">
                            <v-text-field v-model="fileName" 
                                          label="Target file name" 
                                          :rules="[rules.required]"
                                          hint="E.g. my-folder/my-file.zip" 
                                          persistent-hint /> 
                        </v-col>
                        <v-col cols="12" sm="4">
                            <v-text-field v-model="bucketName" 
                                          label="Target bucket name" 
                                          hint="Optional. E.g. test-bucket" 
                                          persistent-hint /> 
                        </v-col>
                    </v-row>
                </v-card-text>
            </v-card>
            <v-card class="mt-5">
                <v-card-title>Deployment</v-card-title>
                <v-card-text>
                    Then select the deployment options: 
                    <v-row cols="12">
                        <v-col cols="6" sm="2">
                            <v-checkbox v-model="deployToDev" label="Dev" hint="Dev bucket" persistent-hint/>
                        </v-col>
                         <v-col cols="6" sm="2">
                            <v-checkbox v-model="deployToProd" label="Prod" hint="Prod bucket" persistent-hint/>
                        </v-col>
                        <v-col cols="12">
                            <v-text-field v-model="deployDate" 
                                          label="Deploy date" 
                                          hint="Format: yyyy-MM-dd HH:mm. Example: 2019-08-29 19:31"
                                          persistent-hint />
                        </v-col>
                    </v-row>
                </v-card-text>
            </v-card>
            <v-row class="mt-5 pr-5">
                <v-spacer />
                <v-btn color="primary" ripple @click="start">Submit</v-btn>
            </v-row>
        </v-form>
    </v-container> 
</template>

<script>
import axios from 'axios'
const GET_SIGNED_URL_FN = "https://europe-west1-pijam-app-reloaded.cloudfunctions.net/signed-url"
export default {
    name: "Home",  
    methods: {
        start: async function() {
            if (!this.$refs.form.validate()) {
                return;
            }

            try {
                const response = await axios.post(GET_SIGNED_URL_FN, {
                    "filename": this.fileName,
                    //"contentType": this.file.type,
                    "method": "PUT"
                });         
                const url = response.data.url;
                this.uploadFile(url);
                //validate file
            }
            catch (e) {
                this.$log.debug(e.response);
            }
        },
        uploadProgress: function(progressEvent) {
            this.uploadPercentage = parseInt(Math.round((progressEvent.loaded * 100) / progressEvent.total) );
            this.$log.info(`${this.uploadPercentage}%`)
        },
        uploadFile: async function(url) {
            try {
                let formData = new FormData();
                formData.append('file', this.file);
                await axios.put(url, this.file, {
                    headers: {
                        'Content-Type': this.file.type
                    },
                    onUploadProgress: this.uploadProgress
                });
                this.$log.debug("file uploaded")
            }
            catch(e) {
                this.$log.debug("couldn't upload file", e);
            }
        }
    },
    data: () => ({
        valid: false,
        file: undefined,
        fileName: undefined,
        bucketName: undefined,
        deployToDev: false,
        deployToProd: false,
        deployDate: undefined,
        rules: {
            required: value => !!value || 'Required.',
        }
    }),
};
</script>
